/* 2 September 2001, Alexandros Droseltis */
/* This file includes the print-funcions, i.e. the functions that print the output of the programm
   on the screen or on the file */

#define MENGE 12
void copyright(char infilename[]);
void print_score(char infilename[], char input1[][12][2], char input2[][12][2], char input3[][12][2], char input4[][12][2], char title[]);
void print_slice(char infilename[], char input[][12][2], char type[], int d);
void clear_file(char infilename[]);
void print_slice2(char infilename[], char input[][12][2], char type[], int d);



void print_score(char infilename[], char input1[][12][2], char input2[][12][2], char input3[][12][2], char input4[][12][2], char title[])
{
  int i, j;
  char type1[3], type2[3], type3[3], type4[3];
  FILE *outfile;

  outfile=fopen(infilename, "a");

  fprintf(outfile, "\\input musixtex\n");
  fprintf(outfile, "\\input musixmad\n\n");

  fprintf(outfile, "\\def\\sp{\\off{0.333\\noteskip}}\n\n");
  fprintf(outfile, "\\def\\numbone#1{\\zcharnote{-7}{\\smalltype #1}}\n");
  fprintf(outfile, "\\def\\numbtwo#1{\\zcharnote{-7}{\\loffset{0.5}{\\smalltype #1}}}\n");

  fprintf(outfile, "\\instrumentnumber{12}\n");
  for(i=0; i<=12; i++)
    {
      fprintf(outfile, "\\setname{%d}{%d}\n", i, 12-i);
    }
  fprintf(outfile, "\\interinstrument = 20pt\n");
  fprintf(outfile, "\\nobarnumbers\n");
  fprintf(outfile, "\\nopagenumbers\n");
  fprintf(outfile, "\\nostartrule\n");
  fprintf(outfile, "\\parindent 10pt\n");
  fprintf(outfile, "\\smallmusicsize\n");
  fprintf(outfile, "\\smallaccid\n");
  fprintf(outfile, "\\hsize=193mm");

  fprintf(outfile, "\\voffset -1.25in\n");
  fprintf(outfile, "\\centerline{\\BIgtype %s}\n", title);
  fprintf(outfile, "\\vskip 30pt\n");

  fprintf(outfile, "\n\\startpiece\n");
  fclose(outfile);

  strcpy(type1, "P");
  strcpy(type2, "R");
  strcpy(type3, "I");
  strcpy(type4, "RI");

  print_slice(infilename, input1, type1, 1);
  print_slice(infilename, input2, type2, 1);
  print_slice(infilename, input3, type3, 1);
  print_slice(infilename, input4, type4, 0);

  outfile=fopen(infilename, "a");
  fprintf(outfile, "\\mulooseness=-2");
  fprintf(outfile, "\\endpiece\n");
  fprintf(outfile, "\\end");
  fclose(outfile);
}

void copyright(char infilename[])
{
  printf("This is TTRM version 1, (Septemper 2001) by A. Droseltis\n");
  printf("Output is written on %s\n", infilename);
}

void print_slice(char infilename[], char input[][12][2], char type[], int d)
{
  int i, j;
  FILE *outfile;

  outfile=fopen(infilename, "a");
  fprintf(outfile, "\\notes%%\n");
  for(j=0; j<11; j++)
    {
      fprintf(outfile, "\\sp");
      for(i=0; i<MENGE; i++)
	{
	  if(i+1<10) fprintf(outfile, "\\numbone{%d}", i+1);
	  else fprintf(outfile, "\\numbtwo{%d}", i+1);
	  fprintf(outfile, "\\nq{%c%c}%%\n", input[11-j][i][0], input[11-j][i][1]);
	}
      fprintf(outfile, "&%%\n");

    }
  fprintf(outfile, "\\Uptext{\\BIgtype %s}%%\n", type);
  
  fprintf(outfile, "\\sp");
  for(i=0; i<MENGE; i++)
    {
      if(i+1<10) fprintf(outfile, "\\numbone{%d}", i+1);
      else fprintf(outfile, "\\numbtwo{%d}", i+1);
      fprintf(outfile, "\\nq{%c%c}%%\n", input[0][i][0], input[0][i][1]);
    }
  if(d==1) fprintf(outfile, "\\en\\bar\n");
  else fprintf(outfile, "\\en\n");
  fclose(outfile);
}

void clear_file(char infilename[])
{
  FILE *outfile;
  outfile=fopen(infilename, "w");
  fprintf(outfile, "");
  fclose(outfile);
}

void print_slice2(char infilename[], char input[][12][2], char type[], int d)
{
  int i, j;
  FILE *outfile;

  outfile=fopen(infilename, "a");
  fprintf(outfile, "\\notes%%\n");
  fprintf(outfile, "%% ");
  fprintf(outfile, "%s%%\n", type);
  for(j=0; j<11; j++)
    {
      fprintf(outfile, "%% %d%%\n", 11-j);
      fprintf(outfile, "\\sp");
      fprintf(outfile, "\\nq{");
      for(i=0; i<MENGE; i++)
	{
	  fprintf(outfile, "%c%c%%", input[11-j][i][0], input[11-j][i][1]);
	}
      fprintf(outfile, "}&%%\n");

    }
  fprintf(outfile, "\\Uptext{\\BIgtype %s}%%\n", type);

  fprintf(outfile, "%% %d%%\n", 11-j);
  fprintf(outfile, "\\sp");
  fprintf(outfile, "\\nq{");
  for(i=0; i<MENGE; i++)
    {
      fprintf(outfile, "%c%c%%", input[0][i][0], input[0][i][1]);
    }
  if(d==1) fprintf(outfile, "}\\en\\bar\n");
  else fprintf(outfile, "}\\en\n");
  fclose(outfile);
}
